﻿using Syncfusion.XForms.ComboBox;
using Syncfusion.XForms.Themes;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.SfDataGrid.XForms;

namespace ComboBox
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class DataGridPage : ContentPage
    {
        public DataGridPage()
        {
            InitializeComponent();
            listOptions = new ObservableCollection<string> { "1", "2", "3", "4", "5", "6" };
            Rows = new ObservableCollection<Row>();
            this.ResultsGrid.Columns.Add(new GridTextColumn() { MappingName = "Col1", HeaderText = "Column 1", Width = 120 });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col2", HeaderText = "Column 2", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col3", HeaderText = "Column 3", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col4", HeaderText = "Column 4", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col5", HeaderText = "Column 5", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTextColumn() { MappingName = "Col6", HeaderText = "Column 6", Width = 120 });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col7", HeaderText = "Column 7", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col8", HeaderText = "Column 8", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col9", HeaderText = "Column 9", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col10", HeaderText = "Column 10", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col11", HeaderText = "Column 11", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col12", HeaderText = "Column 12", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col13", HeaderText = "Column 13", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
            this.ResultsGrid.Columns.Add(new GridTemplateColumn() { MappingName = "Col14", HeaderText = "Column 14", Width = 120, CellTemplate = (DataTemplate)Resources["dropDownColumn"] });
        }

        public ObservableCollection<string> listOptions { get; set; }

        public ObservableCollection<Row> Rows { get; set; }

        public class Row : INotifyPropertyChanged
        {
            private string col1;
            private string col2;
            private string col3;
            private string col4;
            private string col5;
            private string col6;
            private string col7;
            private string col8;
            private string col9;
            private string col10;
            private string col11;
            private string col12;
            private string col13;
            private string col14;

            public int RowNumber { get; set; }

            public string Col1 { get { return col1; } set { this.col1 = value; RaisePropertyChanged("Col1"); } }
            public string Col2 { get { return col2; } set { this.col2 = value; RaisePropertyChanged("Col2"); } }
            public string Col3 { get { return col3; } set { this.col3 = value; RaisePropertyChanged("Col3"); } }
            public string Col4 { get { return col4; } set { this.col4 = value; RaisePropertyChanged("Col4"); } }
            public string Col5 { get { return col5; } set { this.col5 = value; RaisePropertyChanged("Col5"); } }
            public string Col6 { get { return col6; } set { this.col6 = value; RaisePropertyChanged("Col6"); } }
            public string Col7 { get { return col7; } set { this.col7 = value; RaisePropertyChanged("Col7"); } }
            public string Col8 { get { return col8; } set { this.col8 = value; RaisePropertyChanged("Col8"); } }
            public string Col9 { get { return col9; } set { this.col9 = value; RaisePropertyChanged("Col9"); } }
            public string Col10 { get { return col10; } set { this.col10 = value; RaisePropertyChanged("Col10"); } }
            public string Col11 { get { return col11; } set { this.col11 = value; RaisePropertyChanged("Col11"); } }
            public string Col12 { get { return col12; } set { this.col12 = value; RaisePropertyChanged("Col12"); } }
            public string Col13 { get { return col13; } set { this.col13 = value; RaisePropertyChanged("Col13"); } }
            public string Col14 { get { return col14; } set { this.col14 = value; RaisePropertyChanged("Col14"); } }

            public event PropertyChangedEventHandler PropertyChanged;
            private void RaisePropertyChanged(String Name)
            {
                if (PropertyChanged != null)
                    this.PropertyChanged(this, new PropertyChangedEventArgs(Name));
            }
        }


        protected override void OnBindingContextChanged()
        {
            ObservableCollection<Row> rows = new ObservableCollection<Row>();
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            rows.Add(new Row());
            Rows = new ObservableCollection<Row>(rows);
            OnPropertyChanged("Rows");
            OnPropertyChanged();
        }
    }
}
